<?php
$version = "MultiScript v0.88";	
$n = chr(0x0d) . chr(0x0a);

	include "config.php";

	$file = rawurldecode($argv[2]);
	$dir = dirname($file);

	
//index
	$ONSFVUPLOADED  = 1;
	$ONSFVSUCCESS   = 2;
	$ONSFVPREDELETE = 3;
	$ONSFVCOMPLETE  = 4;
	$ONNEWDIR       = 5;	
	$ONSFVFAILED    = 6;
	$ONMP3UPLOADED  = 7;
	$ONCUSTOMCOMMAND = 8;
	$ONUSERLOGIN    = 9;
	$ONUSERLOGINFAILED = 10;
	$ONUSERLOGOUT   = 11;
	$ONFILEUPLOADED = 12;

switch ($argv[1]) {
	
/*-------------------------------------------------------------------------------------------------------------*/
	case $ONSFVUPLOADED:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON SFV UPLOADED_----------------");
	WriteLog ("file received: " . $file);

	//so fr die nicht-mp3 compatibility muss ich hier die sfv auslesen
	$thissfv = fopen($file, "r");
	$buffer = fgets($thissfv, 4096);
	while (1) {
		if (feof($thissfv) && ($nomp3 == 0)) {
			mkdir(dirname($file) . "\\no mp3 here", 0777); 
			WriteLog("-no mp3-sfv received"); 
			break;
		}
	
		if (substr($buffer, 0, 1) != ";") {
			$ext = substr(strrchr($buffer, "."), 0, 4);
			if ($ext == ".mp3") break;
		}
		$buffer = fgets($thissfv, 4096);
	}
	


	$fcnt = $argv[3];
	$scnt = $argv[4];

	
	CreateIncomplete ($dir);
	CreateMissing ($file);
	CreateBar ($dir, $scnt, $fcnt);
	DeleteNoSFVInfo ($dir);


/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
	case $ONSFVSUCCESS:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON SFV SUCCESS_----------------");
	WriteLog ("file received: " . $file);

	$fcnt = $argv[3];
	$scnt = $argv[4];

	
	if(strrchr($file, ".") == ".mp3") {

		$j = 6;
		while (1) {
			if ($argv[$j] == "kbit/s") break;
			$j++;
		}
	
		$bitrate = $argv[$j-1];
		$year = $argv[$j+1];
		$genre = "";

		if (($j-1) >= 5) {
		
			$i = 5;
			for ($i = 5; $i < ($j-1); $i++) {
				$genre .= $argv[$i] . "+";
			} 

		$genre = rtrim($genre);
		$genre = substr($genre, 0, strlen($genre)-1);
		}
	}
// . . . . . . . .
// delete single -missing file
// . . . . . . . . 

	$miss = $file . $misspat;
	if ($missmode == 0) {
	
	} elseif ($missmode == 1) {
		if (is_file($miss)) {
			unlink ($miss);			
			WriteLog ("-missing-file deleted: " . $miss);
		} else {
			WriteLog ("-is no missing-file " . $miss);
		}

	} elseif ($missmode == 2) {
		if (is_dir($miss)) {
			rmdir ($miss);			
			WriteLog ("-missing-dir deleted: " . $miss);
		} else {
			WriteLog ("-is no missing-dir: " . $miss);
		}
	}

//
//####
//

	DeleteBar ($dir, $scnt - 1, $fcnt);
	CreateBar ($dir, $scnt, $fcnt); 
	if (($scnt != $fcnt) && (strrchr($file, ".") == ".mp3")) CreateInfo ($dir, $genre, $year, $bitrate, 2);	
	DeleteNoSFVInfo ($dir);
	
		
/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
	case $ONSFVCOMPLETE:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON SFV COMPLETE_----------------");
	WriteLog (".sfv complete: " . $dir);

	$fcnt = $argv[3];
	$scnt = $argv[4];


	DeleteIncomplete ($dir);
	DeleteBar ($dir, $fcnt - 1, $scnt);
	DeleteNoSFVInfo ($dir);

// . . . . . . . 
// create info dir 
// . . . . . . . 
	if(strrchr($file, ".") == ".mp3") {
		
		$j = 6;
		while (1) {
			if ($argv[$j] == "kbit/s") break;
			$j++;
		}
	
	
		$bitrate = $argv[$j-1];
		$year = $argv[$j+1];
		$genre = "";

		if (($j-1) >= 5) {
		
			$i = 5;
			for ($i = 5; $i < ($j-1); $i++) {
				$genre .= $argv[$i] . "+";
			} 

		$genre = rtrim($genre);
		$genre = substr($genre, 0, strlen($genre)-1);
		}


		CreateInfo ($dir, $genre, $year, $bitrate, 3);
		DeleteInfoIncomplete ($dir, $genre, $year, $bitrate);

	} else {
		//weil ich die sfv hier nicht mehr auslesen kann muss ich das vorher machen und nen marker setzen
		//so den marker testen
		if ((is_dir(dirname($file) . "\\no mp3 here")) || ($nomp3 == 1)) {
			rmdir(dirname($file) . "\\no mp3 here");
			CreateInfo ($dir, $genre, $year, $bitrate, 4);
		} else {
			CreateInfo ($dir, $genre, $year, $bitrate, 1);
		}
	}
// 
//####
//


/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
case $ONSFVFAILED:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON SFV FAILED_----------------");
	WriteLog ("damaged mp3: " . $file);
	if ($deletefailed == 1) {
		unlink ($file . ".bad");
		WriteLog ("damaged mp3 deleted");
	}

	$user = $argv[3];
	$date = $argv[4];
	$time = $argv[5];

	if ($errlog != "") {
		$err = fopen($errlog , "a");
		fwrite ($err, "damaged file: " . $file . $n);
		fwrite ($err, "uploaded by: " . $user . $n);
		fwrite ($err, "on: " . $date . " - " . $time . " o'clock" . $n . $n);
	}

	DeleteNoSFVInfo ($dir);


/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
case $ONSFVPREDELETE:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON SFV PREDELETE_----------------");
	WriteLog ("prepare deletion: " . $file);

	$fcnt = $argv[3];
	$scnt = $argv[4];

	
	DeleteIncomplete ($dir);
	DeleteMissing ($file);
	DeleteBar ($dir, $scnt, $fcnt);


/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*------------------------------------------------------------------------------------------------------------*/
case $ONNEWDIR:
/*-------------------------------------------------------------------------------------------------------------*/
	$dir = $file;
	WriteLog ($n . $n . "----------------_ON NEW DIR_----------------");
	
	if ($makecreatorinfo == 1) {
		WriteLog ("new directory: " . $dir);

		$username = $argv[3];
		$creatorinfo = $dir . "\\@" . $username; 

		mkdir ($creatorinfo, 0777);
		WriteLog ("-CreatorInfo created: " . $creatorinfo);
	}
	
	
/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
case $ONMP3UPLOADED:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON MP3 UPLOADED_----------------");
	WriteLog ("MP3 received: " . $file);

	$i = 0;
	$isnotagdir = 0;

//
// test if no-tag-dir and create info dir
//
	
	while ($notags[$i] != "") {
		if (strtolower($dir) == strtolower($notags[$i])) {
			$isnotagdir = 1;
			WriteLog ("-is notagdir: " . $dir);
			break;
		}
	$i++;
	}

	if ($isnotagdir == 1) break;

	$j = 6;
	while (1) {
		if ($argv[$j] == "kbit/s") break;
		$j++;
	}
	
	
	$bitrate = $argv[$j-1];
	$year = $argv[$j+1];
	$genre = "";

	if (($j-1) >= 5) {
		
		$i = 5;
		for ($i = 5; $i < ($j-1); $i++) {
			$genre .= $argv[$i] . "+";
		} 

	$genre = rtrim($genre);
	$genre = substr($genre, 0, strlen($genre)-1);
	}
	
	
	CreateInfo ($dir, $genre, $year, $bitrate, 2);
	CreateNoSFVInfo ($dir);
//
//####
//


/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
case $ONUSERLOGIN:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON USER LOGIN_----------------");
	WriteLog ("user logged in: " . $argv[2]);

	exec  ($raidendir . "\\makelist.bat " . $physicalroot . " " . $raidendir . "\\dir.txt " . $raidendir . "\\mp3.txt");

	WriteLog("search database updated");
	

/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
case $ONUSERLOGINFAILED:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON USER LOGIN FAILED_----------------");
	WriteLog ("user name: " . $argv[2]);
	WriteLog ("user ip: " . $argv[3]);

	// ip holen
	$byte[0] = strtok($argv[3], ".");

	for ($i = 1; $i < 4; $i++) $byte[$i] = strtok(".");
	$byte[3] .= $n;


	//neverban ips schauen
	if (is_file($raidendir . "\\" . $neverbanlist)) {

		$neverban = fopen($raidendir . "\\" . $neverbanlist, "r");
		$buffer = fgets($neverban, 4096);
		
		while ($buffer != "") {
			$nobanbyte[0] = strtok($buffer, ".");
			for ($i = 1; $i < 4; $i++) $nobanbyte[$i] = strtok(".");

			if ( (($nobanbyte[0] == "*") || ($nobanbyte[0] == $byte[0])) && (($nobanbyte[1] == "*") || ($nobanbyte[1] == $byte[1])) && (($nobanbyte[2] == "*") || ($nobanbyte[2] == $byte[2])) && (($nobanbyte[3] == "*") || ($nobanbyte[3] == $byte[3])) ) {
				$breakit = 1;
				WriteLog("-no ban, ip is in no-ban-list");
				break;
			}
		$buffer = fgets($neverban, 4096);
		}
	}
	fclose ($neverban);

	if ($breakit) break;

	
	if (($useban == 1) && ($argv[4] <= $argv[5])) {

		// so ip hab ich und ip ist nicht in neverban und server ist nicht voll -> ip testen, und evntl bannen

		// ip testen
		$newlist = fopen($raidendir . "\\templist.txt", "w");
		$count = 1; 
				
		if (is_file($raidendir . "\\iplist.txt")) {
			
			$iplist = fopen($raidendir . "\\iplist.txt", "r");
			
			$buffer = fgets($iplist, 4096);
			while (!feof($iplist) && ($buffer != "")) {
				
				$date = strtok($buffer, " ");
				$time = strtok(" ");
				$ip = strtok(" ");
			
				//ip auf datum und zeit testen
				if (timediff($date, $time, $argv[6], $argv[7]) <= $watchmins) {
							
					if ($ip == $argv[3] . $n) $count++;
					fwrite($newlist, $buffer);
				}
				
				$buffer = fgets($iplist, 4096);
			}
		}
		
		WriteLog("this ip failed ". $count . " of " . $bancount . " times in the last " . $watchmins . " minutes");
		if ($count >= $bancount) {
			//banit
			WriteLog("banning this ip");
			if (is_file($raidendir . "\\" . $ipallow)) {
				$banlist = fopen($raidendir . "\\" . $ipallow, "r+");
				while (1) {
					if (feof($banlist)) {
						fwrite($banlist, "!" . $argv[3] . $n); 
						WriteLog("ip banned"); 
						if ($hacker != "") {
							$hacklog = fopen($hacker, "a");
							fwrite($hacklog, $argv[6] . " - " . $argv[7] . " ; possible hacking attempt. ip banned: " . $argv[3] . $n);
							fclose($hacklog);
						}
						break;
					}
					
					if (fgets($banlist, 4096) == "!" . $argv[3] . $n) {
						WriteLog("already banned"); 
						break;
					}
				}
		
			} else {
				$banlist = fopen($raidendir . "\\" . $ipallow, "w");
				fwrite($banlist, "!" . $argv[3] . $n);
				WriteLog("ip banned");
				if ($hacker != "") {
					$hacklog = fopen($hacker, "a");
					fwrite($hacklog, $argv[6] . " - " . $argv[7] . " ; possible hacking attempt. ip banned: " . $argv[3] . $n);
					fclose($hacklog);
				}
			}
			
			fclose ($banlist);
		
		} else {
			fwrite($newlist, $argv[6] . " " . $argv[7] . " " . $argv[3] . $n);
		}
	
	fclose($iplist);
	fclose($newlist);
	copy($raidendir . "\\templist.txt", $raidendir . "\\iplist.txt");
	unlink($raidendir . "\\templist.txt");	
	
	}	
		
	if (($usehammer == 1) && ($argv[4] > $argv[5])) {
		WriteLog("initiating anti-hammer");
	
		// ip testen
		$newlist = fopen($raidendir . "\\templist.txt", "w");
		$count = 0; 
				
		if (is_file($raidendir . "\\hammerlist.txt")) {
			
			$iplist = fopen($raidendir . "\\hammerlist.txt", "r");
			
			$buffer = fgets($iplist, 4096);
			while (!feof($iplist) && ($buffer != "")) {
				
				$date = strtok($buffer, " ");
				$time = strtok(" ");
				$ip = strtok(" ");
			
				//ip auf datum und zeit testen
				if (timediff($date, $time, $argv[6], $argv[7]) <= $hammermins) {
							
					if ($ip == $argv[3] . $n) $count++;
					fwrite($newlist, $buffer);
				}
				
				$buffer = fgets($iplist, 4096);
			}
		}
		
		WriteLog("this ip hammered ". $count . " of " . $hammercount . " times in the last " . $hammermins . " minutes");
		if ($count >= $hammercount) {
			//banit
			WriteLog("banning this ip");
			if (is_file($raidendir . "\\" . $ipallow)) {
				$banlist = fopen($raidendir . "\\" . $ipallow, "r+");
				while (1) {
					if (feof($banlist)) {
						fwrite($banlist, "!" . $argv[3] . $n); 
						WriteLog("ip banned due to hammering"); 
						
						break;
					}
					
					if (fgets($banlist, 4096) == "!" . $argv[3] . $n) {
						WriteLog("already banned"); 
						break;
					}
				}
		
			} else {
				$banlist = fopen($raidendir . "\\" . $ipallow, "w");
				fwrite($banlist, "!" . $argv[3] . $n);
				WriteLog("ip banned due to hammering");
				
			}
			
			fclose ($banlist);
		
		} else {
			fwrite($newlist, $argv[6] . " " . $argv[7] . " " . $argv[3] . $n);
		}
	
	fclose($iplist);
	fclose($newlist);
	copy($raidendir . "\\templist.txt", $raidendir . "\\hammerlist.txt");
	unlink($raidendir . "\\templist.txt");	
	
	}		
		
		
		
		
	





/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
case $ONCUSTOMCOMMAND:
/*-------------------------------------------------------------------------------------------------------------*/
	$id = $argv[6];
	$com = $argv[7]; //this does NOT include everything after the SITE COM - thats stored in $argv[8] - ...	
	WriteLog ($n . $n . "----------------_ON CUSTOM COMMAND_----------------");
	WriteLog ("custom command: " . $com);

	$out = fopen($raidendir . "\\output\\site-" . $com . "." . $id, "w");



	switch($com)
	{

		case "vers": 
		case "script":
		case "version":
			fwrite($out, "...::: MultiScript :::..." . $n);
			fwrite($out, $version);
		break;

		case "find":
		case "search":
			//1st of all get the values
			
			$i = 8;
			if (strtolower($argv[8]) == "mp3") {
				$diroff = 1;
				$i = 9;

			} elseif (strtolower($argv[8]) == "dir") {
				$mp3off = 1;
				$i = 9;
			}
			
			while ($argv[$i] != "") {
				$search .= " " . $argv[$i];
				$i++;
			}
			$search = ltrim(rtrim($search));
			
			fwrite($out, "--------------------------------------------------" . $n);				
			fwrite($out, "Search results:" . $n);				

			if (($diroff != 1) && (is_file($raidendir . "\\dir.txt"))) {
				$pdir = fopen($raidendir . "\\dir.txt", "r+");
				while (!feof($pdir))		
				{
					$buffer = fgets($pdir, 4096);
					if ($buffer != "") {
						if (stristr($buffer, $search)) {
							fwrite($out, "-> " . strtr(substr($buffer, strlen($physicalroot)), "\\", "/"));
						}
					}
				}
				fclose ($pdir);			
			}

			if (($mp3off != 1) && (is_file($raidendir . "\\mp3.txt"))) {
				$pmp3 = fopen($raidendir . "\\mp3.txt", "r+");
				while (!feof($pmp3))		
				{
					$buffer = fgets($pmp3, 4096);
					if ($buffer != "") {
						if (stristr($buffer, $search)) {
							fwrite($out, "-> " . strtr(substr($buffer, strlen($physicalroot)), "\\", "/"));
						}
					}
				
				}
				fclose ($pmp3);	
			}
					
			fwrite($out, "Search complete" . $n);				
			fwrite($out, "--------------------------------------------------" . $n);			
		break;
			
		case "update":
			if ($argv[3] == 0) {
				exec  ($raidendir . "\\makelist.bat " . $physicalroot . " " . $raidendir . "\\dir.txt " . $raidendir . "\\mp3.txt");

				fwrite($out, "search database updated" . $n);				
				WriteLog("search database updated");

			} else {
				fwrite($out, "you dont have permission to perform this command" . $n);				
			}
		break;

		case "request":
			if ($usereq == 0) break;

			// den request string holen
			$i = 8;
			$request = "";
			while ($argv[$i] != "") {
				$request .= " " . $argv[$i];
				$i++;
			}			
			if ($request == "") break;

			// die dateien ffnen
			if (is_file($raidendir . "\\message\\" . $reqname)) $oldfile = fopen($raidendir . "\\message\\" . $reqname, "r");
			$newfile = fopen($raidendir . "\\message\\temp.txt", "w");

			// so jetzt den kopf schreiben und beim alten berspringen
			$i = 0;
			while ($reqhline[$i] != "") {
				fwrite($newfile, $reqhline[$i] . $n);
				if ($oldfile != "") fgets($oldfile, 4096);
				$i++;
			}

			// die alten requests in die neue datei kopieren
			$count = 0;
			if ($oldfile != "") {
				$buffer = fgets($oldfile, 4096);
								
				while (($buffer != $reqbline[0] . $n) && (!feof($oldfile))) {
					fwrite($newfile, $buffer);
					$count++;
					$buffer = fgets($oldfile, 4096);
				}
			}

			// den neuen request anfgen
			$reqtext = $reqleft . addzeros($count + 1, 2) . str_repeat(" ", $reqspc) . addspaces($argv[2], $reqnamelen) . str_repeat(" ", $reqspc) . addspaces($request, $reqlen) . $reqright;
			fwrite($newfile, $reqtext . $n);

			// die bottomlines schreiben
			$i = 0;
			while ($reqbline[$i] != "") {
				fwrite($newfile, $reqbline[$i] . $n);
				$i++;
			}

			//die dateien schlieen, die alte lschen und die neue umbennenen
			fclose($newfile);
			fclose($oldfile);
			copy($raidendir . "\\message\\temp.txt", $raidendir . "\\message\\" . $reqname);
			copy($raidendir . "\\message\\temp.txt", $reqpath . "\\" . $reqname);
			unlink($raidendir . "\\message\\temp.txt");	
			
			// und was ins fenster schreiben
			fwrite($out, "the request was posted as number " . ($count + 1));
			WriteLog("request posted by: " . $argv[2] . " : " . $request);
		break;

		case "delrequest":
			if ($usereq == 0) break;

			//erstmal schauen dass auch root-user
			if ($argv[3] != 0) {
				fwrite($out, "you don't have permission to perform this command");
				WriteLog("no permission: " . $argv[2]);
				break;
			}
			
			// die dateien ffnen, abbruch wenn keine requests
			if (!is_file($raidendir . "\\message\\" . $reqname)) {
				fwrite($out, "no requests posted!");
				break;
			}
			
			$oldfile = fopen($raidendir . "\\message\\" . $reqname, "r");
			$newfile = fopen($raidendir . "\\message\\temp.txt", "w");

			// so jetzt den kopf schreiben und beim alten berspringen
			$i = 0;
			while ($reqhline[$i] != "") {
				fwrite($newfile, $reqhline[$i] . $n);
				if ($oldfile != "") fgets($oldfile, 4096);
				$i++;
			}

			// die alten requests in die neue datei kopieren
			$count = 0;
			$buffer = fgets($oldfile, 4096);
			while ((!feof($oldfile)) && ($buffer != $reqbline[0] . $n)) {
				$count++;

				if ($count == $argv[8]) {
					$request = $buffer;
					$gotit = 1;
				
				} else {
					if ($gotit == 1) $buffer = $reqleft . addzeros($count - 1, 2) . spacediff(substr($buffer, strlen($reqleft)));
					fwrite($newfile, $buffer);
				}
				$buffer = fgets($oldfile, 4096);
			}
			$request = str_replace($n, "", $request);

			// die bottomlines schreiben
			$i = 0;
			while ($reqbline[$i] != "") {
				fwrite($newfile, $reqbline[$i] . $n);
				$i++;
			}

			//die dateien schlieen, die alte lschen und die neue umbennenen
			fclose($newfile);
			fclose($oldfile);
			copy($raidendir . "\\message\\temp.txt", $raidendir . "\\message\\" . $reqname);
			copy($raidendir . "\\message\\temp.txt", $reqpath . "\\" . $reqname);
			unlink($raidendir . "\\message\\temp.txt");	
			
			// den output schreiben
			fwrite ($out, "request deleted: " . $request);
			WriteLog("request deleted: " . $request);
		break;
		
		case "fillrequest":
			if ($usereq == 0) break;

			// die dateien ffnen, abbruch wenn keine requests
			if (!is_file($raidendir . "\\message\\" . $reqname)) {
				fwrite($out, "no requests posted!");
				break;
			}
			
			$oldfile = fopen($raidendir . "\\message\\" . $reqname, "r");
			$newfile = fopen($raidendir . "\\message\\temp.txt", "w");

			// so jetzt den kopf schreiben und beim alten berspringen
			$i = 0;
			while ($reqhline[$i] != "") {
				fwrite($newfile, $reqhline[$i] . $n);
				if ($oldfile != "") fgets($oldfile, 4096);
				$i++;
			}

			// die alten requests in die neue datei kopieren
			$count = 0;
			$buffer = fgets($oldfile, 4096);
			while ((!feof($oldfile)) && ($buffer != $reqbline[0] . $n)) {
				$count++;

				if ($count == $argv[8]) {
					$request = $buffer;
					$gotit = 1;
				
				} else {
					if ($gotit == 1) $buffer = $reqleft . addzeros($count - 1, 2) . spacediff(substr($buffer, strlen($reqleft)));
					fwrite($newfile, $buffer);
				}
				$buffer = fgets($oldfile, 4096);
			}
			$request = str_replace($n, "", $request);

			// die bottomlines schreiben
			$i = 0;
			while ($reqbline[$i] != "") {
				fwrite($newfile, $reqbline[$i] . $n);
				$i++;
			}

			//die dateien schlieen, die alte lschen und die neue umbennenen
			fclose($newfile);
			fclose($oldfile);
			copy($raidendir . "\\message\\temp.txt", $raidendir . "\\message\\" . $reqname);
			copy($raidendir . "\\message\\temp.txt", $reqpath . "\\" . $reqname);
			unlink($raidendir . "\\message\\temp.txt");	
			
			// nicht das einer einen request filled dens nicht gibt
			if ($request == "") {
				fwrite($out, "no request with that number");
				break;
			}

			$rt = substr($request, strlen($reqleft));
			$rt = ltrim(spacediff(ltrim(spacediff($rt))));
			$requesttext = rtrim(substr($rt, 0, strlen($rt) - strlen($reqright)));
						
			// das request verzeichnis erstellen, wenn noch nicht vorhanden und das request unterverzeichnis machen
			if (!is_dir($reqpath)) mkdir($reqpath, 0777);
			$requestnewdir = $reqpath . "\\[REQUEST]-[" . $requesttext . "]";
			mkdir($requestnewdir, 0777);
			mkdir($requestnewdir . "\\filled by " . $argv[2], 0777);

			//ins mboard posten
			if ($postfilled == 1) WriteMBoardentry("Request filled: [" . $requesttext . "]  by: " . $argv[2], $out, $argv[2]);
			
			
			
			// den output schreiben
			fwrite ($out, "please upload in " . str_replace("\\", "/", substr($requestnewdir, strlen($physicalroot))));
			WriteLog("request filled by " . $argv[2] . " : " . $request);
		break;

		case "showreq":
			if ($usereq == 0) break;

			if (!is_file($raidendir . "\\message\\" . $reqname)) {
				fwrite($out, "Keine Requests vorhanden");
				break;
			}

			$reqfile = fopen($raidendir . "\\message\\" . $reqname, "r");
			while (!feof($reqfile)) fwrite($out, fgets($reqfile, 4096));
		break;

		case "message":
			
			if ($useboard == 0) break;

			// die nachricht holen
			$i = 8;
			$message = "";
			while ($argv[$i] != "") {
				$message .= " " . $argv[$i];
				$i++;
			}			
			if ($message == "") break;

			WriteMBoardentry($message, $out, $argv[2]);
			
			// und was ins fenster schreiben

			WriteLog("message posted by " . $argv[2] . " : " . $message);		

		break;

		case "delmessage":
			if ($useboard == 0) break;

			//erstmal schauen dass auch root-user
			if ($argv[3] != 0) {
				fwrite($out, "you don't have permission to perform this command");
				WriteLog("no permission: " . $argv[2]);
				break;
			}

			// die dateien ffnen, abbruch wenn keine messages
			if (!is_file($raidendir . "\\message\\" . $boardname)) {
				fwrite($out, "no messages posted");
				break;
			}
			
			$oldfile = fopen($raidendir . "\\message\\" . $boardname, "r");
			$newfile = fopen($raidendir . "\\message\\temp.txt", "w");

			// so jetzt den kopf schreiben und beim alten berspringen
			$i = 0;
			while ($boardhline[$i] != "") {
				fwrite($newfile, $boardhline[$i] . $n);
				if ($oldfile != "") fgets($oldfile, 4096);
				$i++;
			}

			// die alten messages in die neue datei kopieren
			$count = 0;
			$buffer = fgets($oldfile, 4096);
			while ((!feof($oldfile)) && ($buffer != $boardbline[0] . $n)) {
				$count++;

				if ($count == $argv[8]) {
					$gotit = 1;
					$message = $buffer;

				} else {
					if ($gotit == 1) $buffer = $boardleft . addzeros($count - 1, 2) . spacediff(substr($buffer, strlen($boardleft)));
					fwrite($newfile, $buffer);
				}
				$buffer = fgets($oldfile, 4096);
			}
			$message = str_replace($n, "", $message);

			// die bottomlines schreiben
			$i = 0;
			while ($boardbline[$i] != "") {
				fwrite($newfile, $boardbline[$i] . $n);
				$i++;
			}

			//die dateien schlieen, die alte lschen und die neue umbennenen
			fclose($newfile);
			fclose($oldfile);
			copy($raidendir . "\\message\\temp.txt", $raidendir . "\\message\\" . $boardname);
			unlink($raidendir . "\\message\\temp.txt");	
			
			//ouput
			fwrite($out, "message deleted: " . $message);
			WriteLog("message deleted: " . $message);
		break;
		
		case "board":
			if ($useboard == 0) break;

			if (!is_file($raidendir . "\\message\\" . $boardname)) {
				fwrite($out, "no messages posted");
				break;
			}

			$boardfile = fopen($raidendir . "\\message\\" . $boardname, "r");
			while (!feof($boardfile)) fwrite($out, fgets($boardfile, 4096));
		break;
		
		case "commands":
			if (!is_file($raidendir . "\\commands.txt")) {
				fwrite($out, "commands help not available");
				break;
			}
			$com = fopen($raidendir . "\\commands.txt", "r");
			while (!feof($com)) {
				$buffer = fgets($com, 4096);
				fwrite($out, $buffer);
			}
		break;
	}
	

	
/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
case $ONUSERLOGOUT:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON USER LOGOUT_----------------");
	WriteLog ("users still logged in: " . ($argv[2]-1));

	WriteLog("output folder cleaned");	
	exec ($raidendir . "\\dele.bat " . $raidendir);


/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/
case $ONFILEUPLOADED:
/*-------------------------------------------------------------------------------------------------------------*/
	WriteLog ($n . $n . "----------------_ON FILE UPLOADED_----------------");
	WriteLog ("file uploaded: " . $file);
	
	if ($infofile != "") {
		$info = fopen($dir . "\\" . $infofile, "a");
		fwrite($info, basename($file) . str_repeat(" ", 5) . "by " . $argv[3] . str_repeat(" ", 5) . $argv[4] . " - " . $argv[5] . $n);
		fclose($info);
	}
	
	
/*-------------------------------------------------------------------------------------------------------------*/
	break;
/*-------------------------------------------------------------------------------------------------------------*/

}


//Functions


function WriteLog ($string)
{
global $logpath;
	if ($logpath == "") return;
	$log = fopen($logpath, "a");	
	fwrite($log, $string . chr(0x0d) . chr(0x0a));
	fclose($log);
}




function GetBar ($p)
{
global $prolength;
global $profull;
global $proempty;

	$full = round(($p / 100) * $prolength);
	$empty = $prolength - $full;
	$ret = "[";

	for ( $i = 1 ; $i <= $full ; $i++ ) {
		$ret .= $profull;		
	}
	for ( $i = 1 ; $i <= $empty ; $i++) {
		$ret .= $proempty;
	}
	$ret .= "]";
	return $ret;
}





function CreateIncomplete ($dir)
{
global $incmode;
global $incpat;	
	if ($incmode  == 0) {

	} elseif ($incmode == 1) {
		$incpath = dirname($dir) . "\\" . $incpat . basename($dir);

		$fp = fopen($incpath, "w");
		fclose($fp);

		WriteLog ("-incomplete-file created: " . $incpath);
	} elseif ($incmode == 2) {
		$incpath = dirname($dir) . "\\" . $incpat . basename($dir);
		
		mkdir($incpath, 0777);

		WriteLog ("-incomplete-dir created: " . $incpath);
	}	
}

function DeleteIncomplete ($dir)
{
global $incmode;
global $incpat;	
	if ($incmode  == 0) {

	} elseif ($incmode == 1) {
		$incpath = dirname($dir) . "\\" . $incpat . basename($dir);

		unlink($incpath);

		WriteLog("-incomplete-file deleted: " . $incpath);		

	} elseif ($incmode == 2) {
		$incpath = dirname($dir) . "\\" . $incpat . basename($dir);

		rmdir($incpath);

		WriteLog("-incomplete-dir deleted: " . $incpath);	

	}
}





function CreateMissing ($sfv) 
{
global $missmode;
global $misspat;	
	if ($missmode == 0) {

	} elseif ($missmode == 1) {
		$fd = fopen ($sfv, "r");
		$dir = dirname($sfv);
		WriteLog (".sfv opened: " . $sfv);

		while (!feof($fd))		
		{
			$buffer = fgets($fd, 4096);
			if (!stristr($buffer, ";") && ($buffer != ""))
			{
				
				$cs = strrchr($buffer, " ");
				$fn = $dir . "\\" . substr($buffer, 0, strlen($buffer) - strlen($cs));
				
				if (!is_file($fn))
				{
					$newfile = fopen($fn . $misspat, "w");
					fclose($newfile);
					WriteLog ("-missing-file created: ". $fn);
				}
			}
		}
		fclose ($fd);
	
	} elseif ($missmode == 2) {
		$fd = fopen ($sfv, "r");
		$dir = dirname($sfv);
		WriteLog (".sfv opened: " . $sfv);

		while (!feof($fd))		
		{
			$buffer = fgets($fd, 4096);
			if (!stristr($buffer, ";") && ($buffer != ""))
			{
				
				$cs = strrchr($buffer, " ");
				$fn = $dir . "\\" . substr($buffer, 0, strlen($buffer) - strlen($cs));
				
				if (!is_dir($fn))
				{
					mkdir($fn . $misspat, 0777);
					WriteLog ("-missing-dir created: ". $fn);
				}
			}
		}
		fclose ($fd);
	}
}

function DeleteMissing ($sfv) 
{
global $missmode;
global $misspat;	
	if ($missmode == 0) {

	} elseif ($missmode == 1) {
		$fd = fopen ($sfv, "r");
		$dir = dirname($sfv);
		WriteLog (".sfv opened: " . $sfv);

		while (!feof($fd))		
		{
			$buffer = fgets($fd, 4096);
			if (!stristr($buffer, ";") && ($buffer != ""))
			{
					
				$cs = strrchr($buffer, " ");	
				$fn = $dir . "\\" . substr($buffer, 0, strlen($buffer) - strlen($cs)) . $misspat;
				
				if (is_file($fn))
				{
					unlink($fn);
					WriteLog ("-missing-file deleted: ". $fn);
				} else {
					WriteLog ("-is no missing-file: " . $fn);
				}
			}
		}
	fclose ($fd);
	
	} elseif ($missmode == 2) {
		$fd = fopen ($sfv, "r");
		$dir = dirname($sfv);
		WriteLog (".sfv opened: " . $sfv);

		while (!feof($fd))		
		{
			$buffer = fgets($fd, 4096);
			if (!stristr($buffer, ";") && ($buffer != ""))
			{
				
				$cs = strrchr($buffer, " ");
				$fn = $dir . "\\" . substr($buffer, 0, strlen($buffer) - strlen($cs)) . $misspat;
				
				if (is_dir($fn)) {
					rmdir($fn);
					WriteLog ("-missing-dir deleted: ". $fn);
				} else {
					WriteLog ("-is no missing-dir: " . $fn);
				}
			}
		}
		fclose ($fd);
	}	
}





function CreateBar ($dir, $scnt, $fcnt)
{
global $promode;
	if ($scnt == $fcnt) return;
	if ($promode  == 0) {

	} elseif ($promode == 1) {
		$pc = round($scnt / $fcnt, 3) * 100;
		
		$pdir = $dir . "\\--" . $pc . "%_Completed--" . GetBar($pc) . "-[" . $scnt . " of " . $fcnt . "]";
		$fp = fopen($pdir, "w");
		fclose($fp);

		WriteLog ("-progress-file created: " . $pdir);

	} elseif ($promode == 2) {
		$pc = round($scnt / $fcnt, 3) * 100;
		
		$pdir = $dir . "\\--" . $pc . "%_Completed--" . GetBar($pc) . "-[" . $scnt . " of " . $fcnt . "]";
		mkdir($pdir, 0777);

		WriteLog ("-progress-dir created: " . $pdir);
	}
}

function DeleteBar ($dir, $scnt, $fcnt)
{
global $promode;
	if ($promode  == 0) {

	} elseif ($promode == 1) {
		$pc = round($scnt / $fcnt, 3) * 100;
		
		$pdir = $dir . "\\--" . $pc . "%_Completed--" . GetBar($pc) . "-[" . $scnt . " of " . $fcnt . "]";
		if (is_file($pdir)) {
			unlink($pdir);
			WriteLog ("-progress-file deleted: " . $pdir);
		} else {
			WriteLog ("-is no progress-file: " . $pdir);
		}

	} elseif ($promode == 2) {
		$pc = round($scnt / $fcnt, 3) * 100;
		
		$pdir = $dir . "\\--" . $pc . "%_Completed--" . GetBar($pc) . "-[" . $scnt . " of " . $fcnt . "]";
		if (is_dir($pdir)) {
			rmdir($pdir);
			WriteLog ("-progress-dir deleted: " . $pdir);
		} else { 
			WriteLog ("-is no progress-dir: " . $pdir);
		}
	}
}





function CreateInfo ($dir, $genre, $year, $bps, $style)
{
global $completemode;
	if ($completemode == 0) return;
	if ($style != 1) {
		if ($genre == "") $genre = "X"; else $genre = rawurldecode($genre);
		if ($year == "") $year = "XXXX";
		if ($bps == "") $bps = "XXX";
	}

	$ipath = $dir . "\\[";

	if ($style == 1) {
		$ipath .= basename($dir) . "]--reupload a song";

	} elseif($style == 2) {
		$ipath .= basename($dir) . "]--" . $genre . "-" . $bps . "Kbps-" . $year;
	
	} elseif($style == 3) {
		$ipath .= "COMPLETE]--" . $genre . "-" . $bps . "Kbps-" . $year;
	
	} elseif($style == 4) {  //some not-mp3-server compatibility stuff
		$ipath .= "COMPLETE]--all files uploaded";
	}

	if ($completemode == 1) {
		mkdir($ipath, 0777);
		WriteLog ("-tagdir made: " . $ipath);
		
	} elseif ($completemode == 2) {
		$file = fopen($ipath, "w");
		fclose($file);
		WriteLog ("-tagfile made: " . $ipath);
		
	}
}


function DeleteInfoIncomplete ($dir, $genre, $year, $bps)
{
global $completemode;
	if ($completemode == 0) return;
	$ipath = $dir . "\\[" . basename($dir) . "]--reupload a song";
	if (is_dir($ipath)) {
		rmdir($ipath); 
		WriteLog ("-incomplete infodir deleted: " . $ipath); 
	
	} else {
		WriteLog("-is no incomplete infodir: " . $ipath);
	
	}

	if ($genre == "") $genre = "X"; else ($genre = rawurldecode($genre));
	if ($year == "") $year = "XXXX";
	if ($bps == "") $bps = "XXX";	

	$ipath = $dir . "\\[" . basename($dir) . "]--" . $genre . "-" . $bps . "Kbps-" . $year;
	
	if ($completemode == 1) {
		if (is_dir($ipath)) {
			rmdir($ipath); 
			WriteLog ("-incomplete infodir deleted: " . $ipath); 
		} else { 
				WriteLog("-is no incomplete infodir: " . $ipath);
		}
	
	} elseif ($completemode == 2) {
		if (is_file($ipath)) {
			unlink ($ipath); 
			WriteLog ("-incomplete infodir deleted: " . $ipath); 
		} else { 
			WriteLog("-is no incomplete infodir: " . $ipath);
		}
	}
}





function CreateNoSFVInfo ($dir)
{
global $nosfvpat;
global $nosfvmode;
	$ipath = dirname($dir) . "\\" . basename($dir) . $nosfvpat;
	
	if ($nosfvmode == 0) {

	} elseif ($nosfvmode == 1) {
		$if = fopen($ipath, "w");
		fclose($if);
		WriteLog ("-NoSFVInfo-file created: " . $ipath);

	} elseif ($nosfvmode == 2) {
		mkdir ($ipath, 0777);
		WriteLog ("-NoSFVInfo-dir created: " . $ipath);
	}
}

function DeleteNoSFVInfo ($dir)
{
global $nosfvpat;
global $nosfvmode;
	$ipath = dirname($dir) . "\\" . basename($dir) . $nosfvpat;

	if ($nosfvmode == 0) {

	} elseif ($nosfvmode == 1) {
		unlink($ipath);
		WriteLog ("-NoSFVInfo-file deleted: " . $ipath);

	} elseif ($nosfvmode == 2) {
		rmdir ($ipath);
		WriteLog ("-NoSFVInfo-dir deleted: " . $ipath);
	}
}


function WriteMBoardentry ($message, $out, $name)
{
global $raidendir;
global $boardname;
global $boardhline;
global $boardbline;
global $boardspc;
global $boardnamelen;
global $boardleft;
global $boardright;
global $n;
global $messagelen;

			// die dateien ffnen
			if (is_file($raidendir . "\\message\\" . $boardname)) $oldfile = fopen($raidendir . "\\message\\" . $boardname, "r");
			$newfile = fopen($raidendir . "\\message\\temp.txt", "w");

			// so jetzt den kopf schreiben und beim alten berspringen
			$i = 0;
			while ($boardhline[$i] != "") {
				fwrite($newfile, $boardhline[$i] . $n);
				if ($oldfile != "") fgets($oldfile, 4096);
				$i++;
			}

			// die alten messages in die neue datei kopieren
			$count = 0;
			if ($oldfile != "") {
				$buffer = fgets($oldfile, 4096);
								
				while (($buffer != $boardbline[0] . $n) && (!feof($oldfile))) {
					fwrite($newfile, $buffer);
					$count++;
					$buffer = fgets($oldfile, 4096);
				}
			}

			// die neue nachricht anfgen
			$messagetext = $boardleft . addzeros($count + 1, 2) . str_repeat(" ", $boardspc) . addspaces($name, $boardnamelen) . str_repeat(" ", $boardspc) . $argv[4] . str_repeat(" ", $boardspc) . addspaces($message, $messagelen) . $boardright;
			fwrite($newfile, $messagetext . $n);

			// die bottomlines schreiben
			$i = 0;
			while ($boardbline[$i] != "") {
				fwrite($newfile, $boardbline[$i] . $n);
				$i++;
			}

			//die dateien schlieen, die alte lschen und die neue umbennenen
			fclose($newfile);
			fclose($oldfile);
			copy($raidendir . "\\message\\temp.txt", $raidendir . "\\message\\" . $boardname);
			unlink($raidendir . "\\message\\temp.txt");	
		
			fwrite($out, "the message was posted as number " . ($count + 1) . $n);
			return;
}


function addzeros ($str, $numz) 
{
	if (strlen($str) >= $numz) return $str;

	
	while (strlen($str) < $numz) {
		$str = "0" . $str;
	}
	return $str;
}





function addspaces ($str, $nums)
{
	if (strlen($str) >= $nums) return $str;
	
	while (strlen($str) < $nums) {
		$str .= " ";
	}
	return $str;
}





function spacediff ($str)
{
	$max = strlen($str);
	for ($i = 0; $i < $max; $i++) {
		if (substr($str, $i, 1) == " ") return substr($str, $i);
	}
	return "";
}



function timediff ($date0, $time0, $date1, $time1)
{
	$hours[0] = strtok($time0, ":");
	$mins[0]  = substr(stristr($time0, ":"), 1);

	$hours[1] = strtok($time1, ":");
	$mins[1]  = substr(stristr($time1, ":"), 1);

	// datediff
	$datediff = datediff($date0, $date1);
	$vorz = 1;
	if ($datediff < 0) $datediff = $datediff * -1; $vorz = -1;
	
	$alldiff = $datediff * 24 * 60 + $vorz * (($hours[0] * 60 + $mins[0]) - ($hours[1] * 60 + $mins[1]));
	return $alldiff;
}	


function datediff ($date0, $date1)
{
	if ($date0 == $date1) return 0;
	
	$year[0] 	= strtok($date0, "/");
	$month[0] 	= strtok("/");
	$day[0] 	= substr(strrchr($date0, "/"), 1);

	$year[1] 	= strtok($date1, "/");
	$month[1] 	= strtok("/");
	$day[1] 	= substr(strrchr($date1, "/"), 1);
		
	$yeardiff[0] 	= 2000 - $year[0];
	$yeardiff[1] 	= 2000 - $year[1];

	$nodays[0]	= ($yeardiff[0] * 365) + getupto($day[0], $month[0]);
	$nodays[1]	= ($yeardiff[1] * 365) + getupto($day[1], $month[1]);

	$leaps[0]	= floor(($yeardiff[0] - 1) / 4);
	$leaps[1]	= floor(($yeardiff[1] - 1) / 4);
	
	if (($month[0] > 2) && (isleap($year[0]))) $leaps[0]++;
	if (($month[1] > 2) && (isleap($year[1]))) $leaps[1]++;

	$nodays[0] += $leaps[0];
	$nodays[1] += $leaps[1];

	$daydiff = $nodays[0] - $nodays[1];
	return $daydiff;
}



function getupto($day, $month)
{
	$days[1] 	= 31; 
	$days[2] 	= 28; 
	$days[3] 	= 31; 
	$days[4] 	= 30; 
	$days[5] 	= 31; 
	$days[6] 	= 30; 
	$days[7] 	= 31; 
	$days[8] 	= 31; 
	$days[9] 	= 30;
	$days[10] 	= 31;
	$days[11] 	= 30;
	$days[12] 	= 31;
	
	$retval = 0;
	for ($i = 1; $i < $month; $i++) {
		$retval += $days[$i];
	}
	$retval += $day;
	return $retval;
}


function isleap($year)
{
	if (($year % 4) == 0) return true;
	return false;
}


	


WriteLog("exiting");
fclose($out);

?>
	